=== packages/macports/devel/libnifalcon/Portfile ===
# -*- coding: utf-8; mode: tcl; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- vim:fenc=utf-8:ft=tcl:et:sw=4:ts=4:sts=4

# $Id$

PortSystem  1.0

name        libnifalcon
version     1.0.2
categories  devel
platforms   darwin

maintainers John Richards gmail.com:richardsjohnt

homepage            http://qdot.github.com/libnifalcon/
description         Novint Falcon hardware support
long_description    Driver and development library for the Novint Falcon haptic device

master_sites    sourceforge
checksums       md5     0a3d01945b5274d2cd22aefba547fbd8 \
                sha1    4a4272bc2abaf0b5d82035f0eacde9d468772816 \
                rmd160 4ed16084bd9dc9658af56f40b228a812edfc6951

depends_lib port:cmake \
            port:boost \
            port:libusb

post-extract {
    file mkdir ${worksrcpath}/build
}

configure {
    system "cd ${worksrcpath}/build \
            && cmake -DCMAKE_INSTALL_PREFIX=${prefix} -G \"Unix Makefiles\" .."
}

build.dir       ${worksrcpath}/build
